pipeline{
    agent any

    stages{
        /*
        stage ('Build'){
            steps {
                echo "Building the package"
                sh 'mvn clean package'
            }
            post{
                success{
                    echo "Now Archiving the artifact"
                    //below command creates artifact in the context of the job it is running. So it is not directly available to other job.
                    archiveArtifacts artifacts: '** /*.war' //space added to escape comment lines
                }
            }
        }
        */
        stage ('Build'){
            steps{
                echo "Buidling the package through exisiting Job - SampleWebApp-Build"
                build job: 'SampleWebApp-Build'
            }
        }
        stage ('Delploy to Staging'){
            steps{
                 echo "Deploying to Staging environment"
                 build job: 'SampleWebApp-Deploy-Staging'
            }
        }
        stage ('Deploy to PROD'){
            steps{
                timeout(time:5, unit:'DAYS'){
                    input message: 'Do you approve production deployment'
                }
                build job: 'SampleWebApp-Deploy-Prod'
            }
            post {
                success {
                    echo 'Deployment to PROD successful'
                }
                failure {
                    echo 'Deployment to PROD failed'
                }
            }
        }

    }
}